%% InductionMotorODEfunction
function dxdt=IModefunction(t,x)
%motor parameters
Xls=0.0320; %leakage reactance stator
Xlr=0.0100; %leakage reactance rotor
Xm=0.9750;  %mutual reactance

Xr=Xlr+Xm;  %Self reactance rotor
Xs=Xls+Xm;  %Self reactance stator

Lr=Xr/(2*pi*60); %Self inductance rotor
Ls=Xs/(2*pi*60); %Self inductance stator
Lm=Xm/(2*pi*60); %Mutual inductance 
Rs=0.0041; %Resistance stator
Rr=0.0009; %Resistance rotor
P=4;     %number of poles  
Jm=152;  %motor moment of inertia
Jl=0;  %load moment of inertia
Tl=0; %load torque
cf=0.85;  % friction coefficient
V=sqrt(2)*690/sqrt(3); %Peak value phase voltage
J= Jl+Jm; %

%matrices for  state equation


A_inv=[Ls  0     Lm    0      0;
       0   Ls    0    Lm      0;
       Lm   0    Lr    0      0;
       0    Lm   0    Lr      0;
       0    0    0    0       J];

A=inv(A_inv);

B=[Rs              0            0           0           0;
   0               Rs           0           0           0;
   0         (P*Lm*x(5))/2     Rr       (P*x(5)*Lr)/2   0;
  -(P*x(5)*Lm)/2    0    -(P*x(5)*Lr)/2     Rr          0;
   0                0      -(P*Lm*x(2))/3   (P*Lm*x(1))/3   cf  ];

%input setup
   Vas =V* sin(2*pi*60*t);
   Vbs =V* sin(2*pi*60*t - 2/3*pi);
   Vcs =V* sin(2*pi*60*t + 2/3*pi);
   %transform dq stationary(Clark transform)
   Vds= [1 -1/2 -1/2]*[Vas;Vbs;Vcs];
   Vqs= [0 sqrt(3)/2 -sqrt(3)/2]*[Vas;Vbs;Vcs];
   
   %input Vector
    u=[Vds;Vqs;0;0; -Tl];
    
    %state vector  (or use x(1:5) in the state equation)
    x=[x(1);x(2);x(3);x(4);x(5)];
    
 %state equation  
dxdt=A*(u-B*x);



end

