%% Induction motor odesolver

close all; clear all;
tspan=[0 30]; %simulation time
x0=[0; 0; 0; 0; 0]; % Initial conditions for the statevariables 

[t, x]=ode45(@IModefunction,tspan,x0); %ODE solver

%Torque equation
 Lm=0.9750/(2*pi*60);
 P=4;
 T=P*Lm/3*(x(:,3).*x(:,2)-x(:,4).*x(:,1));
 

%dq-stator current absolute value
Idqs_abs= 2/3*(sqrt(x(:,1).^2+x(:,2).^2));


% plots
figure
plot(t,Idqs_abs);
title('dq-stator abs current')
xlabel('time')
ylabel('Ampere')

figure
subplot(5,1,1)
plot(t,x(:,1));
title('Sd-Current')
subplot(5,1,2)
plot(t,x(:,2));
title('Sq-Current')
subplot(5,1,3)
plot(t,x(:,3));
title('Rd-Current')
subplot(5,1,4)
plot(t,x(:,4));
title('Rq-Current')

figure
plot(t,x(:,5));
title('Angular velocity')
xlabel('time')
ylabel('angular velocity')

figure
plot(t,T);
title('Torque vs time')
xlabel('time');
ylabel('torque');

figure
plot(x(:,5),T);
title('Torque speed curve')
xlabel('angular velocity')
ylabel('Torque');



